/*
 -- ============================================================================
 -- FILE NAME	: bus_slave_mux.v
 -- DESCRIPTION : oXX[u}`vNT
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "bus.h"

/********** W[ **********/
module bus_slave_mux (
	/********** `bvZNg **********/
	input  wire				   s0_cs_,	   // oXX[u0
	input  wire				   s1_cs_,	   // oXX[u1
	input  wire				   s2_cs_,	   // oXX[u2
	input  wire				   s3_cs_,	   // oXX[u3
	input  wire				   s4_cs_,	   // oXX[u4
	input  wire				   s5_cs_,	   // oXX[u5
	input  wire				   s6_cs_,	   // oXX[u6
	input  wire				   s7_cs_,	   // oXX[u7
	/********** oXX[uM **********/
	// oXX[u0
	input  wire [`WordDataBus] s0_rd_data, // ǂݏof[^
	input  wire				   s0_rdy_,	   // fB
	// oXX[u1
	input  wire [`WordDataBus] s1_rd_data, // ǂݏof[^
	input  wire				   s1_rdy_,	   // fB
	// oXX[u2
	input  wire [`WordDataBus] s2_rd_data, // ǂݏof[^
	input  wire				   s2_rdy_,	   // fB
	// oXX[u3
	input  wire [`WordDataBus] s3_rd_data, // ǂݏof[^
	input  wire				   s3_rdy_,	   // fB
	// oXX[u4
	input  wire [`WordDataBus] s4_rd_data, // ǂݏof[^
	input  wire				   s4_rdy_,	   // fB
	// oXX[u5
	input  wire [`WordDataBus] s5_rd_data, // ǂݏof[^
	input  wire				   s5_rdy_,	   // fB
	// oXX[u6
	input  wire [`WordDataBus] s6_rd_data, // ǂݏof[^
	input  wire				   s6_rdy_,	   // fB
	// oXX[u7
	input  wire [`WordDataBus] s7_rd_data, // ǂݏof[^
	input  wire				   s7_rdy_,	   // fB
	/********** oX}X^ʐM **********/
	output reg	[`WordDataBus] m_rd_data,  // ǂݏof[^
	output reg				   m_rdy_	   // fB
);

	/********** oXX[u}`vNT **********/
	always @(*) begin
		/* `bvZNgɑΉX[ȗI */
		if (s0_cs_ == `ENABLE_) begin		   // oXX[u0
			m_rd_data = s0_rd_data;
			m_rdy_	  = s0_rdy_;
		end else if (s1_cs_ == `ENABLE_) begin // oXX[u1
			m_rd_data = s1_rd_data;
			m_rdy_	  = s1_rdy_;
		end else if (s2_cs_ == `ENABLE_) begin // oXX[u2
			m_rd_data = s2_rd_data;
			m_rdy_	  = s2_rdy_;
		end else if (s3_cs_ == `ENABLE_) begin // oXX[u3
			m_rd_data = s3_rd_data;
			m_rdy_	  = s3_rdy_;
		end else if (s4_cs_ == `ENABLE_) begin // oXX[u4
			m_rd_data = s4_rd_data;
			m_rdy_	  = s4_rdy_;
		end else if (s5_cs_ == `ENABLE_) begin // oXX[u5
			m_rd_data = s5_rd_data;
			m_rdy_	  = s5_rdy_;
		end else if (s6_cs_ == `ENABLE_) begin // oXX[u6
			m_rd_data = s6_rd_data;
			m_rdy_	  = s6_rdy_;
		end else if (s7_cs_ == `ENABLE_) begin // oXX[u7
			m_rd_data = s7_rd_data;
			m_rdy_	  = s7_rdy_;
		end else begin						   // ftHgl
			m_rd_data = `WORD_DATA_W'h0;
			m_rdy_	  = `DISABLE_;
		end
	end

endmodule
