/*
 -- ============================================================================
 -- FILE NAME	: uart.h
 -- DESCRIPTION : UARTwb_
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

`ifndef __UART_HEADER__
	`define __UART_HEADER__			// CN[hK[h

/*
 * yɂāz
 * EUART̓`bvŜ̊gƂɃ{[[g𐶐Ă܂B
 *	 g{[[gύXꍇ́A
 *	 UART_DIV_RATEUART_DIV_CNT_WUartDivCntBusύXĉB
 * EUART_DIV_RATE͕[g`Ă܂B
 *	 UART_DIV_RATE͊g{[[gŊlɂȂ܂B
 * EUART_DIV_CNT_W͕JE^̕`Ă܂B
 *	 UART_DIV_CNT_WUART_DIV_RATElog2lɂȂ܂B
 * EUartDivCntBusUART_DIV_CNT_W̃oXłB
 *	 UART_DIV_CNT_W-1:0ƂĉB
 *
 * y̗z
 * EUART̃{[[g38,400baudŁA`bvŜ̊g10MHz̏ꍇA
 *	 UART_DIV_RATE10,000,00038,400260ƂȂ܂B
 *	 UART_DIV_CNT_Wlog2(260)9ƂȂ܂B
 */

	/********** JE^ *********/
	`define UART_DIV_RATE	   9'd260  // [g
	`define UART_DIV_CNT_W	   9	   // JE^
	`define UartDivCntBus	   8:0	   // JE^oX
	/********** AhXoX **********/
	`define UartAddrBus		   0:0	// AhXoX
	`define UART_ADDR_W		   1	// AhX
	`define UartAddrLoc		   0:0	// AhẌʒu
	/********** AhX}bv **********/
	`define UART_ADDR_STATUS   1'h0 // 䃌WX^ 0 : Xe[^X
	`define UART_ADDR_DATA	   1'h1 // 䃌WX^ 1 : Mf[^
	/********** rbg}bv **********/
	`define UartCtrlIrqRx	   0	// M荞
	`define UartCtrlIrqTx	   1	// M荞
	`define UartCtrlBusyRx	   2	// MtO
	`define UartCtrlBusyTx	   3	// MtO
	/********** MXe[^X **********/
	`define UartStateBus	   0:0	// Xe[^XoX
	`define UART_STATE_IDLE	   1'b0 // Xe[^X : ACh
	`define UART_STATE_TX	   1'b1 // Xe[^X : M
	`define UART_STATE_RX	   1'b1 // Xe[^X : M
	/********** rbgJE^ **********/
	`define UartBitCntBus	   3:0	// rbgJE^oX
	`define UART_BIT_CNT_W	   4	// rbgJE^
	`define UART_BIT_CNT_START 4'h0 // JEgl : X^[grbg
	`define UART_BIT_CNT_MSB   4'h8 // JEgl : f[^MSB
	`define UART_BIT_CNT_STOP  4'h9 // JEgl : Xgbvrbg
	/********** rbgx **********/
	`define UART_START_BIT	   1'b0 // X^[grbg
	`define UART_STOP_BIT	   1'b1 // Xgbvrbg

`endif
