/*
 -- ============================================================================
 -- FILE NAME	: bus.v
 -- DESCRIPTION : oX
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "bus.h"

/********** W[ **********/
module bus (
	/********** NbN & Zbg **********/
	input  wire				   clk,		   // NbN
	input  wire				   reset,	   // 񓯊Zbg
	/********** oX}X^M **********/
	// oX}X^ʐM
	output wire [`WordDataBus] m_rd_data,  // ǂݏof[^
	output wire				   m_rdy_,	   // fB
	// oX}X^0
	input  wire				   m0_req_,	   // oXNGXg
	input  wire [`WordAddrBus] m0_addr,	   // AhX
	input  wire				   m0_as_,	   // AhXXg[u
	input  wire				   m0_rw,	   // ǂ݁^
	input  wire [`WordDataBus] m0_wr_data, // ݃f[^
	output wire				   m0_grnt_,   // oXOg
	// oX}X^1
	input  wire				   m1_req_,	   // oXNGXg
	input  wire [`WordAddrBus] m1_addr,	   // AhX
	input  wire				   m1_as_,	   // AhXXg[u
	input  wire				   m1_rw,	   // ǂ݁^
	input  wire [`WordDataBus] m1_wr_data, // ݃f[^
	output wire				   m1_grnt_,   // oXOg
	// oX}X^2
	input  wire				   m2_req_,	   // oXNGXg
	input  wire [`WordAddrBus] m2_addr,	   // AhX
	input  wire				   m2_as_,	   // AhXXg[u
	input  wire				   m2_rw,	   // ǂ݁^
	input  wire [`WordDataBus] m2_wr_data, // ݃f[^
	output wire				   m2_grnt_,   // oXOg
	// oX}X^3
	input  wire				   m3_req_,	   // oXNGXg
	input  wire [`WordAddrBus] m3_addr,	   // AhX
	input  wire				   m3_as_,	   // AhXXg[u
	input  wire				   m3_rw,	   // ǂ݁^
	input  wire [`WordDataBus] m3_wr_data, // ݃f[^
	output wire				   m3_grnt_,   // oXOg
	/********** oXX[uM **********/
	// oXX[uʐM
	output wire [`WordAddrBus] s_addr,	   // AhX
	output wire				   s_as_,	   // AhXXg[u
	output wire				   s_rw,	   // ǂ݁^
	output wire [`WordDataBus] s_wr_data,  // ݃f[^
	// oXX[u0
	input  wire [`WordDataBus] s0_rd_data, // ǂݏof[^
	input  wire				   s0_rdy_,	   // fB
	output wire				   s0_cs_,	   // `bvZNg
	// oXX[u1
	input  wire [`WordDataBus] s1_rd_data, // ǂݏof[^
	input  wire				   s1_rdy_,	   // fB
	output wire				   s1_cs_,	   // `bvZNg
	// oXX[u2
	input  wire [`WordDataBus] s2_rd_data, // ǂݏof[^
	input  wire				   s2_rdy_,	   // fB
	output wire				   s2_cs_,	   // `bvZNg
	// oXX[u3
	input  wire [`WordDataBus] s3_rd_data, // ǂݏof[^
	input  wire				   s3_rdy_,	   // fB
	output wire				   s3_cs_,	   // `bvZNg
	// oXX[u4
	input  wire [`WordDataBus] s4_rd_data, // ǂݏof[^
	input  wire				   s4_rdy_,	   // fB
	output wire				   s4_cs_,	   // `bvZNg
	// oXX[u5
	input  wire [`WordDataBus] s5_rd_data, // ǂݏof[^
	input  wire				   s5_rdy_,	   // fB
	output wire				   s5_cs_,	   // `bvZNg
	// oXX[u6
	input  wire [`WordDataBus] s6_rd_data, // ǂݏof[^
	input  wire				   s6_rdy_,	   // fB
	output wire				   s6_cs_,	   // `bvZNg
	// oXX[u7
	input  wire [`WordDataBus] s7_rd_data, // ǂݏof[^
	input  wire				   s7_rdy_,	   // fB
	output wire				   s7_cs_	   // `bvZNg
);

	/********** oXA[r^ **********/
	bus_arbiter bus_arbiter (
		/********** NbN & Zbg **********/
		.clk		(clk),		  // NbN
		.reset		(reset),	  // 񓯊Zbg
		/********** A[rg[VM **********/
		// oX}X^0
		.m0_req_	(m0_req_),	  // oXNGXg
		.m0_grnt_	(m0_grnt_),	  // oXOg
		// oX}X^1
		.m1_req_	(m1_req_),	  // oXNGXg
		.m1_grnt_	(m1_grnt_),	  // oXOg
		// oX}X^2
		.m2_req_	(m2_req_),	  // oXNGXg
		.m2_grnt_	(m2_grnt_),	  // oXOg
		// oX}X^3
		.m3_req_	(m3_req_),	  // oXNGXg
		.m3_grnt_	(m3_grnt_)	  // oXOg
	);

	/********** oX}X^}`vNT **********/
	bus_master_mux bus_master_mux (
		/********** oX}X^M **********/
		// oX}X^0
		.m0_addr	(m0_addr),	  // AhX
		.m0_as_		(m0_as_),	  // AhXXg[u
		.m0_rw		(m0_rw),	  // ǂ݁^
		.m0_wr_data (m0_wr_data), // ݃f[^
		.m0_grnt_	(m0_grnt_),	  // oXOg
		// oX}X^1
		.m1_addr	(m1_addr),	  // AhX
		.m1_as_		(m1_as_),	  // AhXXg[u
		.m1_rw		(m1_rw),	  // ǂ݁^
		.m1_wr_data (m1_wr_data), // ݃f[^
		.m1_grnt_	(m1_grnt_),	  // oXOg
		// oX}X^2
		.m2_addr	(m2_addr),	  // AhX
		.m2_as_		(m2_as_),	  // AhXXg[u
		.m2_rw		(m2_rw),	  // ǂ݁^
		.m2_wr_data (m2_wr_data), // ݃f[^
		.m2_grnt_	(m2_grnt_),	  // oXOg
		// oX}X^3
		.m3_addr	(m3_addr),	  // AhX
		.m3_as_		(m3_as_),	  // AhXXg[u
		.m3_rw		(m3_rw),	  // ǂ݁^
		.m3_wr_data (m3_wr_data), // ݃f[^
		.m3_grnt_	(m3_grnt_),	  // oXOg
		/********** oXX[uʐM **********/
		.s_addr		(s_addr),	  // AhX
		.s_as_		(s_as_),	  // AhXXg[u
		.s_rw		(s_rw),		  // ǂ݁^
		.s_wr_data	(s_wr_data)	  // ݃f[^
	);

	/********** AhXfR[_ **********/
	bus_addr_dec bus_addr_dec (
		/********** AhX **********/
		.s_addr		(s_addr),	  // AhX
		/********** `bvZNg **********/
		.s0_cs_		(s0_cs_),	  // oXX[u0
		.s1_cs_		(s1_cs_),	  // oXX[u1
		.s2_cs_		(s2_cs_),	  // oXX[u2
		.s3_cs_		(s3_cs_),	  // oXX[u3
		.s4_cs_		(s4_cs_),	  // oXX[u4
		.s5_cs_		(s5_cs_),	  // oXX[u5
		.s6_cs_		(s6_cs_),	  // oXX[u6
		.s7_cs_		(s7_cs_)	  // oXX[u7
	);

	/********** oXX[u}`vNT **********/
	bus_slave_mux bus_slave_mux (
		/********** `bvZNg **********/
		.s0_cs_		(s0_cs_),	  // oXX[u0
		.s1_cs_		(s1_cs_),	  // oXX[u1
		.s2_cs_		(s2_cs_),	  // oXX[u2
		.s3_cs_		(s3_cs_),	  // oXX[u3
		.s4_cs_		(s4_cs_),	  // oXX[u4
		.s5_cs_		(s5_cs_),	  // oXX[u5
		.s6_cs_		(s6_cs_),	  // oXX[u6
		.s7_cs_		(s7_cs_),	  // oXX[u7
		/********** oXX[uM **********/
		// oXX[u0
		.s0_rd_data (s0_rd_data), // ǂݏof[^
		.s0_rdy_	(s0_rdy_),	  // fB
		// oXX[u1
		.s1_rd_data (s1_rd_data), // ǂݏof[^
		.s1_rdy_	(s1_rdy_),	  // fB
		// oXX[u2
		.s2_rd_data (s2_rd_data), // ǂݏof[^
		.s2_rdy_	(s2_rdy_),	  // fB
		// oXX[u3
		.s3_rd_data (s3_rd_data), // ǂݏof[^
		.s3_rdy_	(s3_rdy_),	  // fB
		// oXX[u4
		.s4_rd_data (s4_rd_data), // ǂݏof[^
		.s4_rdy_	(s4_rdy_),	  // fB
		// oXX[u5
		.s5_rd_data (s5_rd_data), // ǂݏof[^
		.s5_rdy_	(s5_rdy_),	  // fB
		// oXX[u6
		.s6_rd_data (s6_rd_data), // ǂݏof[^
		.s6_rdy_	(s6_rdy_),	  // fB
		// oXX[u7
		.s7_rd_data (s7_rd_data), // ǂݏof[^
		.s7_rdy_	(s7_rdy_),	  // fB
		/********** oX}X^ʐM **********/
		.m_rd_data	(m_rd_data),  // ǂݏof[^
		.m_rdy_		(m_rdy_)	  // fB
	);

endmodule
