/* 
 -- ============================================================================
 -- FILE NAME	: isa.h
 -- DESCRIPTION : ߃ZbgA[LeN`
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

`ifndef __ISA_HEADER__
	`define __ISA_HEADER__			 // Include Guard

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
	/**********  **********/
	`define ISA_NOP			   32'h0 // No Operation
	/********** IyR[h **********/
	// oX
	`define ISA_OP_W		   6	 // IyR[h
	`define IsaOpBus		   5:0	 // IyR[hoX
	`define IsaOpLoc		   31:26 // IyR[ḧʒu
	// IyR[h
	`define ISA_OP_ANDR		   6'h00 // WX^m̘_
	`define ISA_OP_ANDI		   6'h01 // WX^ƒ萔̘_
	`define ISA_OP_ORR		   6'h02 // WX^m̘_a
	`define ISA_OP_ORI		   6'h03 // WX^ƒ萔̘_a
	`define ISA_OP_XORR		   6'h04 // WX^m̔rI_a
	`define ISA_OP_XORI		   6'h05 // WX^ƒ萔̔rI_a
	`define ISA_OP_ADDSR	   6'h06 // WX^m̕tZ
	`define ISA_OP_ADDSI	   6'h07 // WX^ƒ萔̕tZ
	`define ISA_OP_ADDUR	   6'h08 // WX^m̕ȂZ
	`define ISA_OP_ADDUI	   6'h09 // WX^ƒ萔̕ȂZ
	`define ISA_OP_SUBSR	   6'h0a // WX^m̕tZ
	`define ISA_OP_SUBUR	   6'h0b // WX^m̕ȂZ
	`define ISA_OP_SHRLR	   6'h0c // WX^m̘_EVtg
	`define ISA_OP_SHRLI	   6'h0d // WX^ƒ萔̘_EVtg
	`define ISA_OP_SHLLR	   6'h0e // WX^m̘_Vtg
	`define ISA_OP_SHLLI	   6'h0f // WX^ƒ萔̘_Vtg
	`define ISA_OP_BE		   6'h10 // WX^m̕tr(==)
	`define ISA_OP_BNE		   6'h11 // WX^m̕tr(!=)
	`define ISA_OP_BSGT		   6'h12 // WX^m̕tr(<)
	`define ISA_OP_BUGT		   6'h13 // WX^m̕Ȃr(<)
	`define ISA_OP_JMP		   6'h14 // WX^w̐Ε
	`define ISA_OP_CALL		   6'h15 // WX^w̃Tu[`R[
	`define ISA_OP_LDW		   6'h16 // [hǂݏo
	`define ISA_OP_STW		   6'h17 // [h
	`define ISA_OP_TRAP		   6'h18 // gbv
	`define ISA_OP_RDCR		   6'h19 // 䃌WX^̓ǂݏo
	`define ISA_OP_WRCR		   6'h1a // 䃌WX^ւ̏
	`define ISA_OP_EXRT		   6'h1b // O̕A
	/********** WX^AhX **********/
	// oX
	`define ISA_REG_ADDR_W	   5	 // WX^AhX
	`define IsaRegAddrBus	   4:0	 // WX^AhXoX
	`define IsaRaAddrLoc	   25:21 // WX^Räʒu
	`define IsaRbAddrLoc	   20:16 // WX^Rb̈ʒu
	`define IsaRcAddrLoc	   15:11 // WX^Rc̈ʒu
	/********** l **********/
	// oX
	`define ISA_IMM_W		   16	 // l̕
	`define ISA_EXT_W		   16	 // l̕g
	`define ISA_IMM_MSB		   15	 // l̍ŏʃrbg
	`define IsaImmBus		   15:0	 // l̃oX
	`define IsaImmLoc		   15:0	 // l̈ʒu

//------------------------------------------------------------------------------
// O
//------------------------------------------------------------------------------
	/********** OR[h **********/
	// oX
	`define ISA_EXP_W		   3	 // OR[h
	`define IsaExpBus		   2:0	 // OR[hoX
	// O
	`define ISA_EXP_NO_EXP	   3'h0	 // OȂ
	`define ISA_EXP_EXT_INT	   3'h1	 // O荞
	`define ISA_EXP_UNDEF_INSN 3'h2	 // `
	`define ISA_EXP_OVERFLOW   3'h3	 // ZpI[ot[
	`define ISA_EXP_MISS_ALIGN 3'h4	 // AhX~XAC
	`define ISA_EXP_TRAP	   3'h5	 // gbv
	`define ISA_EXP_PRV_VIO	   3'h6	 // ᔽ

`endif
