/*
 -- ============================================================================
 -- FILE NAME	: rom.h
 -- DESCRIPTION : ROM wb_
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

`ifndef __ROM_HEADER__
	`define __ROM_HEADER__			  // CN[hK[h

/*
 * yROM̃TCYɂāz
 * EROM̃TCYύXɂ́A
 *	 ROM_SIZEAROM_DEPTHAROM_ADDR_WARomAddrBusARomAddrLocύXĉB
 * EROM_SIZEROM̃TCY`Ă܂B
 * EROM_DEPTHROM̐[`Ă܂B
 *	 ROM͊̕{I32biti4BytejŒȂ̂ŁA
 *	 ROM_DEPTHROM_SIZE4ŊlɂȂ܂B
 * EROM_ADDR_WROM̃AhX`ĂA
 *	 ROM_DEPTHlog2lɂȂ܂B
 * ERomAddrBusRomAddrLocROM_ADDR_W̃oXłB
 *	 ROM_ADDR_W-1:0ƂĉB
 *
 * yROM̃TCY̗z
 * EROM̃TCY8192Bytei4KBj̏ꍇA
 *	 ROM_DEPTH819242048
 *	 ROM_ADDR_Wlog2(2048)11ƂȂ܂B
 */

	`define ROM_SIZE   8192	// ROM̃TCY
	`define ROM_DEPTH  2048	// ROM̐[
	`define ROM_ADDR_W 11	// AhX
	`define RomAddrBus 10:0 // AhXoX
	`define RomAddrLoc 10:0 // AhẌʒu

`endif
