/*
 -- ============================================================================
 -- FILE NAME	: x_s3e_dcm.v
 -- DESCRIPTION : Xilinx Spartan-3E DCM ^f
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"

/********** W[ **********/
module x_s3e_dcm (
	input  wire CLKIN_IN,		 // NbN
	input  wire RST_IN,			 // Zbg
	output wire CLK0_OUT,		 // NbNi0j
	output wire CLK180_OUT,		 // NbNi180j
	output wire LOCKED_OUT		 // bN
);

	/********** NbNo **********/
	assign CLK0_OUT	  = CLKIN_IN;
	assign CLK180_OUT = ~CLKIN_IN;
	assign LOCKED_OUT = ~RST_IN;
   
endmodule
