/*
 -- ============================================================================
 -- FILE NAME	: x_s3e_sprom.v
 -- DESCRIPTION : Xilinx Spartan-3E Single Port ROM ^f
 -- ----------------------------------------------------------------------------
 -- Revision  Date		  Coding_by	 Comment
 -- 1.0.0	  2011/06/27  suito		 VK쐬
 -- ============================================================================
*/

/********** ʃwb_t@C **********/
`include "nettype.h"
`include "stddef.h"
`include "global_config.h"

/********** ʃwb_t@C **********/
`include "rom.h"

/********** W[ **********/
module x_s3e_sprom (
	input wire				  clka,	 // NbN
	input wire [`RomAddrBus]  addra, // AhX
	output reg [`WordDataBus] douta	 // ǂݏof[^
);

	/**********  **********/
	reg [`WordDataBus] mem [0:`ROM_DEPTH-1];

	/********** ǂݏoANZX **********/
	always @(posedge clka) begin
		douta <= #1 mem[addra];
	end

endmodule
